// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_msgs:msg/AudioFeatures.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__AUDIO_FEATURES__STRUCT_HPP_
#define HRI_MSGS__MSG__DETAIL__AUDIO_FEATURES__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__hri_msgs__msg__AudioFeatures __attribute__((deprecated))
#else
# define DEPRECATED__hri_msgs__msg__AudioFeatures __declspec(deprecated)
#endif

namespace hri_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AudioFeatures_
{
  using Type = AudioFeatures_<ContainerAllocator>;

  explicit AudioFeatures_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->zcr = 0.0f;
      this->rms = 0.0f;
      this->pitch = 0.0f;
      this->hnr = 0.0f;
    }
  }

  explicit AudioFeatures_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->zcr = 0.0f;
      this->rms = 0.0f;
      this->pitch = 0.0f;
      this->hnr = 0.0f;
    }
  }

  // field types and members
  using _zcr_type =
    float;
  _zcr_type zcr;
  using _rms_type =
    float;
  _rms_type rms;
  using _pitch_type =
    float;
  _pitch_type pitch;
  using _hnr_type =
    float;
  _hnr_type hnr;
  using _mfcc_type =
    std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>>;
  _mfcc_type mfcc;

  // setters for named parameter idiom
  Type & set__zcr(
    const float & _arg)
  {
    this->zcr = _arg;
    return *this;
  }
  Type & set__rms(
    const float & _arg)
  {
    this->rms = _arg;
    return *this;
  }
  Type & set__pitch(
    const float & _arg)
  {
    this->pitch = _arg;
    return *this;
  }
  Type & set__hnr(
    const float & _arg)
  {
    this->hnr = _arg;
    return *this;
  }
  Type & set__mfcc(
    const std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>> & _arg)
  {
    this->mfcc = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hri_msgs::msg::AudioFeatures_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_msgs::msg::AudioFeatures_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_msgs::msg::AudioFeatures_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_msgs::msg::AudioFeatures_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::AudioFeatures_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::AudioFeatures_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::AudioFeatures_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::AudioFeatures_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_msgs::msg::AudioFeatures_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_msgs::msg::AudioFeatures_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_msgs__msg__AudioFeatures
    std::shared_ptr<hri_msgs::msg::AudioFeatures_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_msgs__msg__AudioFeatures
    std::shared_ptr<hri_msgs::msg::AudioFeatures_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AudioFeatures_ & other) const
  {
    if (this->zcr != other.zcr) {
      return false;
    }
    if (this->rms != other.rms) {
      return false;
    }
    if (this->pitch != other.pitch) {
      return false;
    }
    if (this->hnr != other.hnr) {
      return false;
    }
    if (this->mfcc != other.mfcc) {
      return false;
    }
    return true;
  }
  bool operator!=(const AudioFeatures_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AudioFeatures_

// alias to use template instance with default allocator
using AudioFeatures =
  hri_msgs::msg::AudioFeatures_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hri_msgs

#endif  // HRI_MSGS__MSG__DETAIL__AUDIO_FEATURES__STRUCT_HPP_
