// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hri_msgs:msg/IdsList.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__IDS_LIST__TRAITS_HPP_
#define HRI_MSGS__MSG__DETAIL__IDS_LIST__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hri_msgs/msg/detail/ids_list__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace hri_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const IdsList & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: ids
  {
    if (msg.ids.size() == 0) {
      out << "ids: []";
    } else {
      out << "ids: [";
      size_t pending_items = msg.ids.size();
      for (auto item : msg.ids) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const IdsList & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: ids
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.ids.size() == 0) {
      out << "ids: []\n";
    } else {
      out << "ids:\n";
      for (auto item : msg.ids) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const IdsList & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hri_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_msgs::msg::IdsList & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hri_msgs::msg::IdsList & msg)
{
  return hri_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hri_msgs::msg::IdsList>()
{
  return "hri_msgs::msg::IdsList";
}

template<>
inline const char * name<hri_msgs::msg::IdsList>()
{
  return "hri_msgs/msg/IdsList";
}

template<>
struct has_fixed_size<hri_msgs::msg::IdsList>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<hri_msgs::msg::IdsList>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<hri_msgs::msg::IdsList>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HRI_MSGS__MSG__DETAIL__IDS_LIST__TRAITS_HPP_
