// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_msgs:msg/NormalizedRegionOfInterest2D.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__NORMALIZED_REGION_OF_INTEREST2_D__STRUCT_H_
#define HRI_MSGS__MSG__DETAIL__NORMALIZED_REGION_OF_INTEREST2_D__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/NormalizedRegionOfInterest2D in the package hri_msgs.
/**
  * This contains the top-leftmost and bottom-rightmost coordinates of a region of interest (typically in an image)
  * the coordinates are always normalized and must belong to [0.,1.].
  * The (xmin, ymin) tuple stores the top-leftmost coordinates of the ROI, while (xmax, ymax) represents the
  * bottom-rightmost coordinates.
  * c is a confidence level (between 0. and 1.) associated to that ROI
 */
typedef struct hri_msgs__msg__NormalizedRegionOfInterest2D
{
  /// Header timestamp should be acquisition time of the original image
  std_msgs__msg__Header header;
  float xmin;
  float ymin;
  float xmax;
  float ymax;
  float c;
} hri_msgs__msg__NormalizedRegionOfInterest2D;

// Struct for a sequence of hri_msgs__msg__NormalizedRegionOfInterest2D.
typedef struct hri_msgs__msg__NormalizedRegionOfInterest2D__Sequence
{
  hri_msgs__msg__NormalizedRegionOfInterest2D * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_msgs__msg__NormalizedRegionOfInterest2D__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_MSGS__MSG__DETAIL__NORMALIZED_REGION_OF_INTEREST2_D__STRUCT_H_
