// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_msgs:msg/NormalizedRegionOfInterest2D.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__NORMALIZED_REGION_OF_INTEREST2_D__STRUCT_HPP_
#define HRI_MSGS__MSG__DETAIL__NORMALIZED_REGION_OF_INTEREST2_D__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_msgs__msg__NormalizedRegionOfInterest2D __attribute__((deprecated))
#else
# define DEPRECATED__hri_msgs__msg__NormalizedRegionOfInterest2D __declspec(deprecated)
#endif

namespace hri_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct NormalizedRegionOfInterest2D_
{
  using Type = NormalizedRegionOfInterest2D_<ContainerAllocator>;

  explicit NormalizedRegionOfInterest2D_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->xmin = 0.0f;
      this->ymin = 0.0f;
      this->xmax = 0.0f;
      this->ymax = 0.0f;
      this->c = 0.0f;
    }
  }

  explicit NormalizedRegionOfInterest2D_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->xmin = 0.0f;
      this->ymin = 0.0f;
      this->xmax = 0.0f;
      this->ymax = 0.0f;
      this->c = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _xmin_type =
    float;
  _xmin_type xmin;
  using _ymin_type =
    float;
  _ymin_type ymin;
  using _xmax_type =
    float;
  _xmax_type xmax;
  using _ymax_type =
    float;
  _ymax_type ymax;
  using _c_type =
    float;
  _c_type c;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__xmin(
    const float & _arg)
  {
    this->xmin = _arg;
    return *this;
  }
  Type & set__ymin(
    const float & _arg)
  {
    this->ymin = _arg;
    return *this;
  }
  Type & set__xmax(
    const float & _arg)
  {
    this->xmax = _arg;
    return *this;
  }
  Type & set__ymax(
    const float & _arg)
  {
    this->ymax = _arg;
    return *this;
  }
  Type & set__c(
    const float & _arg)
  {
    this->c = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hri_msgs::msg::NormalizedRegionOfInterest2D_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_msgs::msg::NormalizedRegionOfInterest2D_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_msgs::msg::NormalizedRegionOfInterest2D_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_msgs::msg::NormalizedRegionOfInterest2D_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::NormalizedRegionOfInterest2D_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::NormalizedRegionOfInterest2D_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::NormalizedRegionOfInterest2D_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::NormalizedRegionOfInterest2D_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_msgs::msg::NormalizedRegionOfInterest2D_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_msgs::msg::NormalizedRegionOfInterest2D_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_msgs__msg__NormalizedRegionOfInterest2D
    std::shared_ptr<hri_msgs::msg::NormalizedRegionOfInterest2D_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_msgs__msg__NormalizedRegionOfInterest2D
    std::shared_ptr<hri_msgs::msg::NormalizedRegionOfInterest2D_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const NormalizedRegionOfInterest2D_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->xmin != other.xmin) {
      return false;
    }
    if (this->ymin != other.ymin) {
      return false;
    }
    if (this->xmax != other.xmax) {
      return false;
    }
    if (this->ymax != other.ymax) {
      return false;
    }
    if (this->c != other.c) {
      return false;
    }
    return true;
  }
  bool operator!=(const NormalizedRegionOfInterest2D_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct NormalizedRegionOfInterest2D_

// alias to use template instance with default allocator
using NormalizedRegionOfInterest2D =
  hri_msgs::msg::NormalizedRegionOfInterest2D_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hri_msgs

#endif  // HRI_MSGS__MSG__DETAIL__NORMALIZED_REGION_OF_INTEREST2_D__STRUCT_HPP_
