// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hri_msgs:msg/SoftBiometrics.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__SOFT_BIOMETRICS__TRAITS_HPP_
#define HRI_MSGS__MSG__DETAIL__SOFT_BIOMETRICS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hri_msgs/msg/detail/soft_biometrics__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace hri_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SoftBiometrics & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: age
  {
    out << "age: ";
    rosidl_generator_traits::value_to_yaml(msg.age, out);
    out << ", ";
  }

  // member: age_confidence
  {
    out << "age_confidence: ";
    rosidl_generator_traits::value_to_yaml(msg.age_confidence, out);
    out << ", ";
  }

  // member: gender
  {
    out << "gender: ";
    rosidl_generator_traits::value_to_yaml(msg.gender, out);
    out << ", ";
  }

  // member: gender_confidence
  {
    out << "gender_confidence: ";
    rosidl_generator_traits::value_to_yaml(msg.gender_confidence, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SoftBiometrics & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: age
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "age: ";
    rosidl_generator_traits::value_to_yaml(msg.age, out);
    out << "\n";
  }

  // member: age_confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "age_confidence: ";
    rosidl_generator_traits::value_to_yaml(msg.age_confidence, out);
    out << "\n";
  }

  // member: gender
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gender: ";
    rosidl_generator_traits::value_to_yaml(msg.gender, out);
    out << "\n";
  }

  // member: gender_confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gender_confidence: ";
    rosidl_generator_traits::value_to_yaml(msg.gender_confidence, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SoftBiometrics & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hri_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_msgs::msg::SoftBiometrics & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hri_msgs::msg::SoftBiometrics & msg)
{
  return hri_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hri_msgs::msg::SoftBiometrics>()
{
  return "hri_msgs::msg::SoftBiometrics";
}

template<>
inline const char * name<hri_msgs::msg::SoftBiometrics>()
{
  return "hri_msgs/msg/SoftBiometrics";
}

template<>
struct has_fixed_size<hri_msgs::msg::SoftBiometrics>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<hri_msgs::msg::SoftBiometrics>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<hri_msgs::msg::SoftBiometrics>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HRI_MSGS__MSG__DETAIL__SOFT_BIOMETRICS__TRAITS_HPP_
