// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_msgs:msg/BodyPosture.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__BODY_POSTURE__STRUCT_HPP_
#define HRI_MSGS__MSG__DETAIL__BODY_POSTURE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_msgs__msg__BodyPosture __attribute__((deprecated))
#else
# define DEPRECATED__hri_msgs__msg__BodyPosture __declspec(deprecated)
#endif

namespace hri_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct BodyPosture_
{
  using Type = BodyPosture_<ContainerAllocator>;

  explicit BodyPosture_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->posture = 0;
    }
  }

  explicit BodyPosture_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->posture = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _posture_type =
    uint8_t;
  _posture_type posture;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__posture(
    const uint8_t & _arg)
  {
    this->posture = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t STANDING =
    1u;
  static constexpr uint8_t SITTING =
    2u;
  static constexpr uint8_t CROUCHING =
    3u;
  static constexpr uint8_t LAYING =
    4u;
  static constexpr uint8_t OTHER =
    0u;

  // pointer types
  using RawPtr =
    hri_msgs::msg::BodyPosture_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_msgs::msg::BodyPosture_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_msgs::msg::BodyPosture_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_msgs::msg::BodyPosture_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::BodyPosture_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::BodyPosture_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::BodyPosture_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::BodyPosture_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_msgs::msg::BodyPosture_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_msgs::msg::BodyPosture_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_msgs__msg__BodyPosture
    std::shared_ptr<hri_msgs::msg::BodyPosture_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_msgs__msg__BodyPosture
    std::shared_ptr<hri_msgs::msg::BodyPosture_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const BodyPosture_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->posture != other.posture) {
      return false;
    }
    return true;
  }
  bool operator!=(const BodyPosture_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct BodyPosture_

// alias to use template instance with default allocator
using BodyPosture =
  hri_msgs::msg::BodyPosture_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t BodyPosture_<ContainerAllocator>::STANDING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t BodyPosture_<ContainerAllocator>::SITTING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t BodyPosture_<ContainerAllocator>::CROUCHING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t BodyPosture_<ContainerAllocator>::LAYING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t BodyPosture_<ContainerAllocator>::OTHER;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace hri_msgs

#endif  // HRI_MSGS__MSG__DETAIL__BODY_POSTURE__STRUCT_HPP_
