// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_msgs:msg/EngagementLevel.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__ENGAGEMENT_LEVEL__STRUCT_H_
#define HRI_MSGS__MSG__DETAIL__ENGAGEMENT_LEVEL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'UNKNOWN'.
/**
  * unknown: no information is provided about the engagement level
 */
enum
{
  hri_msgs__msg__EngagementLevel__UNKNOWN = 0
};

/// Constant 'DISENGAGED'.
/**
  * disengaged: the human has not looked in the direction of the robot
 */
enum
{
  hri_msgs__msg__EngagementLevel__DISENGAGED = 1
};

/// Constant 'ENGAGING'.
/**
  * engaging: the human has started to look in the direction of the robot
 */
enum
{
  hri_msgs__msg__EngagementLevel__ENGAGING = 2
};

/// Constant 'ENGAGED'.
/**
  * engaged: the human is fully engaged with the robot
 */
enum
{
  hri_msgs__msg__EngagementLevel__ENGAGED = 3
};

/// Constant 'DISENGAGING'.
/**
  * disengaging: the human has started to look away from the robot
 */
enum
{
  hri_msgs__msg__EngagementLevel__DISENGAGING = 4
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/EngagementLevel in the package hri_msgs.
/**
  * Discrete engagement levels of a person with respect to the robot
  * It is for instance published on /humans/persons/person_id/engagement_status 
  * to access to the engagement level of a detected human. 
  * It will output one of the five following levels: unknown, disengaged, 
  * engaging, engaged and disengaging.
 */
typedef struct hri_msgs__msg__EngagementLevel
{
  std_msgs__msg__Header header;
  uint8_t level;
} hri_msgs__msg__EngagementLevel;

// Struct for a sequence of hri_msgs__msg__EngagementLevel.
typedef struct hri_msgs__msg__EngagementLevel__Sequence
{
  hri_msgs__msg__EngagementLevel * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_msgs__msg__EngagementLevel__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_MSGS__MSG__DETAIL__ENGAGEMENT_LEVEL__STRUCT_H_
