// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_msgs:msg/FacialActionUnits.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__FACIAL_ACTION_UNITS__STRUCT_HPP_
#define HRI_MSGS__MSG__DETAIL__FACIAL_ACTION_UNITS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_msgs__msg__FacialActionUnits __attribute__((deprecated))
#else
# define DEPRECATED__hri_msgs__msg__FacialActionUnits __declspec(deprecated)
#endif

namespace hri_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FacialActionUnits_
{
  using Type = FacialActionUnits_<ContainerAllocator>;

  explicit FacialActionUnits_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<float, 99>::iterator, float>(this->intensity.begin(), this->intensity.end(), 0.0f);
      std::fill<typename std::array<float, 99>::iterator, float>(this->confidence.begin(), this->confidence.end(), 0.0f);
    }
  }

  explicit FacialActionUnits_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    intensity(_alloc),
    confidence(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<float, 99>::iterator, float>(this->intensity.begin(), this->intensity.end(), 0.0f);
      std::fill<typename std::array<float, 99>::iterator, float>(this->confidence.begin(), this->confidence.end(), 0.0f);
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _intensity_type =
    std::array<float, 99>;
  _intensity_type intensity;
  using _confidence_type =
    std::array<float, 99>;
  _confidence_type confidence;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__intensity(
    const std::array<float, 99> & _arg)
  {
    this->intensity = _arg;
    return *this;
  }
  Type & set__confidence(
    const std::array<float, 99> & _arg)
  {
    this->confidence = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t NEUTRAL_FACE =
    0u;
  static constexpr uint8_t INNER_BROW_RAISER =
    1u;
  static constexpr uint8_t OUTER_BROW_RAISER =
    2u;
  static constexpr uint8_t BROW_LOWERER =
    4u;
  static constexpr uint8_t UPPER_LID_RAISER =
    5u;
  static constexpr uint8_t CHEEK_RAISER =
    6u;
  static constexpr uint8_t LID_TIGHTENER =
    7u;
  static constexpr uint8_t LIPS_TOWARD_EACH_OTHER =
    8u;
  static constexpr uint8_t NOSE_WRINKLER =
    9u;
  static constexpr uint8_t UPPER_LIP_RAISER =
    10u;
  static constexpr uint8_t NASOLABIAL_DEEPENER =
    11u;
  static constexpr uint8_t LIP_CORNER_PULLER =
    12u;
  static constexpr uint8_t SHARP_LIP_PULLER =
    13u;
  static constexpr uint8_t DIMPLER =
    14u;
  static constexpr uint8_t LIP_CORNER_DEPRESSOR =
    15u;
  static constexpr uint8_t LOWER_LIP_DEPRESSOR =
    16u;
  static constexpr uint8_t CHIN_RAISER =
    17u;
  static constexpr uint8_t LIP_PUCKER =
    18u;
  static constexpr uint8_t TONGUE_SHOW =
    19u;
  static constexpr uint8_t LIP_STRETCHER =
    20u;
  static constexpr uint8_t NECK_TIGHTENER =
    21u;
  static constexpr uint8_t LIP_FUNNELER =
    22u;
  static constexpr uint8_t LIP_TIGHTENER =
    23u;
  static constexpr uint8_t LIP_PRESSOR =
    24u;
  static constexpr uint8_t LIPS_PART =
    25u;
  static constexpr uint8_t JAW_DROP =
    26u;
  static constexpr uint8_t MOUTH_STRETCH =
    27u;
  static constexpr uint8_t LIP_SUCK =
    28u;
  static constexpr uint8_t HEAD_TURN_LEFT =
    51u;
  static constexpr uint8_t HEAD_TURN_RIGHT =
    52u;
  static constexpr uint8_t HEAD_UP =
    53u;
  static constexpr uint8_t HEAD_DOWN =
    54u;
  static constexpr uint8_t HEAD_TILT_LEFT =
    55u;
  static constexpr uint8_t HEAD_TILT_RIGHT =
    56u;
  static constexpr uint8_t HEAD_FORWARD =
    57u;
  static constexpr uint8_t HEAD_BACK =
    58u;
  static constexpr uint8_t EYES_TURN_LEFT =
    61u;
  static constexpr uint8_t EYES_TURN_RIGHT =
    62u;
  static constexpr uint8_t EYES_UP =
    63u;
  static constexpr uint8_t EYES_DOWN =
    64u;
  static constexpr uint8_t WALLEYE =
    65u;
  static constexpr uint8_t CROSS_EYE =
    66u;
  static constexpr uint8_t EYES_POSITIONED_TO_LOOK_AT_OTHER_PERSON =
    69u;
  static constexpr uint8_t BROWS_AND_FOREHEAD_NOT_VISIBLE =
    70u;
  static constexpr uint8_t EYES_NOT_VISIBLE =
    71u;
  static constexpr uint8_t LOWER_FACE_NOT_VISIBLE =
    72u;
  static constexpr uint8_t ENTIRE_FACE_NOT_VISIBLE =
    73u;
  static constexpr uint8_t UNSOCIABLE =
    74u;
  static constexpr uint8_t JAW_THRUST =
    29u;
  static constexpr uint8_t JAW_SIDEWAYS =
    30u;
  static constexpr uint8_t JAW_CLENCHER =
    31u;
  static constexpr uint8_t LIP_BITE =
    32u;
  static constexpr uint8_t CHEEK_BLOW =
    33u;
  static constexpr uint8_t CHEEK_PUFF =
    34u;
  static constexpr uint8_t CHEEK_SUCK =
    35u;
  static constexpr uint8_t TONGUE_BULGE =
    36u;
  static constexpr uint8_t LIP_WIPE =
    37u;
  static constexpr uint8_t NOSTRIL_DILATOR =
    38u;
  static constexpr uint8_t NOSTRIL_COMPRESSOR =
    39u;
  static constexpr uint8_t SNIFF =
    40u;
  static constexpr uint8_t LID_DROOP =
    41u;
  static constexpr uint8_t SLIT =
    42u;
  static constexpr uint8_t EYES_CLOSED =
    43u;
  static constexpr uint8_t SQUINT =
    44u;
  static constexpr uint8_t BLINK =
    45u;
  static constexpr uint8_t WINK =
    46u;
  static constexpr uint8_t SPEECH =
    50u;
  static constexpr uint8_t SWALLOW =
    80u;
  static constexpr uint8_t CHEWING =
    81u;
  static constexpr uint8_t SHOULDER_SHRUG =
    82u;
  static constexpr uint8_t HEAD_SHAKE_BACK_AND_FORTH =
    84u;
  static constexpr uint8_t HEAD_NOD_UP_AND_DOWN =
    85u;
  static constexpr uint8_t FLASH =
    91u;
  static constexpr uint8_t PARTIAL_FLASH =
    92u;
  static constexpr uint8_t SHIVER_TREMBLE =
    97u;
  static constexpr uint8_t FAST_UP_DOWN_LOOK =
    98u;

  // pointer types
  using RawPtr =
    hri_msgs::msg::FacialActionUnits_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_msgs::msg::FacialActionUnits_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_msgs::msg::FacialActionUnits_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_msgs::msg::FacialActionUnits_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::FacialActionUnits_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::FacialActionUnits_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::FacialActionUnits_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::FacialActionUnits_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_msgs::msg::FacialActionUnits_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_msgs::msg::FacialActionUnits_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_msgs__msg__FacialActionUnits
    std::shared_ptr<hri_msgs::msg::FacialActionUnits_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_msgs__msg__FacialActionUnits
    std::shared_ptr<hri_msgs::msg::FacialActionUnits_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FacialActionUnits_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->intensity != other.intensity) {
      return false;
    }
    if (this->confidence != other.confidence) {
      return false;
    }
    return true;
  }
  bool operator!=(const FacialActionUnits_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FacialActionUnits_

// alias to use template instance with default allocator
using FacialActionUnits =
  hri_msgs::msg::FacialActionUnits_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::NEUTRAL_FACE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::INNER_BROW_RAISER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::OUTER_BROW_RAISER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::BROW_LOWERER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::UPPER_LID_RAISER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::CHEEK_RAISER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LID_TIGHTENER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LIPS_TOWARD_EACH_OTHER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::NOSE_WRINKLER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::UPPER_LIP_RAISER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::NASOLABIAL_DEEPENER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LIP_CORNER_PULLER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::SHARP_LIP_PULLER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::DIMPLER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LIP_CORNER_DEPRESSOR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LOWER_LIP_DEPRESSOR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::CHIN_RAISER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LIP_PUCKER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::TONGUE_SHOW;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LIP_STRETCHER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::NECK_TIGHTENER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LIP_FUNNELER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LIP_TIGHTENER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LIP_PRESSOR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LIPS_PART;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::JAW_DROP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::MOUTH_STRETCH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LIP_SUCK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::HEAD_TURN_LEFT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::HEAD_TURN_RIGHT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::HEAD_UP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::HEAD_DOWN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::HEAD_TILT_LEFT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::HEAD_TILT_RIGHT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::HEAD_FORWARD;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::HEAD_BACK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::EYES_TURN_LEFT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::EYES_TURN_RIGHT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::EYES_UP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::EYES_DOWN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::WALLEYE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::CROSS_EYE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::EYES_POSITIONED_TO_LOOK_AT_OTHER_PERSON;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::BROWS_AND_FOREHEAD_NOT_VISIBLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::EYES_NOT_VISIBLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LOWER_FACE_NOT_VISIBLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::ENTIRE_FACE_NOT_VISIBLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::UNSOCIABLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::JAW_THRUST;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::JAW_SIDEWAYS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::JAW_CLENCHER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LIP_BITE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::CHEEK_BLOW;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::CHEEK_PUFF;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::CHEEK_SUCK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::TONGUE_BULGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LIP_WIPE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::NOSTRIL_DILATOR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::NOSTRIL_COMPRESSOR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::SNIFF;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::LID_DROOP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::SLIT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::EYES_CLOSED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::SQUINT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::BLINK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::WINK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::SPEECH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::SWALLOW;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::CHEWING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::SHOULDER_SHRUG;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::HEAD_SHAKE_BACK_AND_FORTH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::HEAD_NOD_UP_AND_DOWN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::FLASH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::PARTIAL_FLASH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::SHIVER_TREMBLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FacialActionUnits_<ContainerAllocator>::FAST_UP_DOWN_LOOK;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace hri_msgs

#endif  // HRI_MSGS__MSG__DETAIL__FACIAL_ACTION_UNITS__STRUCT_HPP_
