// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from hri_msgs:msg/FacialLandmarks.idl
// generated code does not contain a copyright notice
#include "hri_msgs/msg/detail/facial_landmarks__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `landmarks`
#include "hri_msgs/msg/detail/normalized_point_of_interest2_d__functions.h"

bool
hri_msgs__msg__FacialLandmarks__init(hri_msgs__msg__FacialLandmarks * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    hri_msgs__msg__FacialLandmarks__fini(msg);
    return false;
  }
  // landmarks
  for (size_t i = 0; i < 70; ++i) {
    if (!hri_msgs__msg__NormalizedPointOfInterest2D__init(&msg->landmarks[i])) {
      hri_msgs__msg__FacialLandmarks__fini(msg);
      return false;
    }
  }
  // height
  // width
  return true;
}

void
hri_msgs__msg__FacialLandmarks__fini(hri_msgs__msg__FacialLandmarks * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // landmarks
  for (size_t i = 0; i < 70; ++i) {
    hri_msgs__msg__NormalizedPointOfInterest2D__fini(&msg->landmarks[i]);
  }
  // height
  // width
}

bool
hri_msgs__msg__FacialLandmarks__are_equal(const hri_msgs__msg__FacialLandmarks * lhs, const hri_msgs__msg__FacialLandmarks * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // landmarks
  for (size_t i = 0; i < 70; ++i) {
    if (!hri_msgs__msg__NormalizedPointOfInterest2D__are_equal(
        &(lhs->landmarks[i]), &(rhs->landmarks[i])))
    {
      return false;
    }
  }
  // height
  if (lhs->height != rhs->height) {
    return false;
  }
  // width
  if (lhs->width != rhs->width) {
    return false;
  }
  return true;
}

bool
hri_msgs__msg__FacialLandmarks__copy(
  const hri_msgs__msg__FacialLandmarks * input,
  hri_msgs__msg__FacialLandmarks * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // landmarks
  for (size_t i = 0; i < 70; ++i) {
    if (!hri_msgs__msg__NormalizedPointOfInterest2D__copy(
        &(input->landmarks[i]), &(output->landmarks[i])))
    {
      return false;
    }
  }
  // height
  output->height = input->height;
  // width
  output->width = input->width;
  return true;
}

hri_msgs__msg__FacialLandmarks *
hri_msgs__msg__FacialLandmarks__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_msgs__msg__FacialLandmarks * msg = (hri_msgs__msg__FacialLandmarks *)allocator.allocate(sizeof(hri_msgs__msg__FacialLandmarks), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hri_msgs__msg__FacialLandmarks));
  bool success = hri_msgs__msg__FacialLandmarks__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hri_msgs__msg__FacialLandmarks__destroy(hri_msgs__msg__FacialLandmarks * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hri_msgs__msg__FacialLandmarks__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hri_msgs__msg__FacialLandmarks__Sequence__init(hri_msgs__msg__FacialLandmarks__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_msgs__msg__FacialLandmarks * data = NULL;

  if (size) {
    data = (hri_msgs__msg__FacialLandmarks *)allocator.zero_allocate(size, sizeof(hri_msgs__msg__FacialLandmarks), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hri_msgs__msg__FacialLandmarks__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hri_msgs__msg__FacialLandmarks__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hri_msgs__msg__FacialLandmarks__Sequence__fini(hri_msgs__msg__FacialLandmarks__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hri_msgs__msg__FacialLandmarks__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hri_msgs__msg__FacialLandmarks__Sequence *
hri_msgs__msg__FacialLandmarks__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_msgs__msg__FacialLandmarks__Sequence * array = (hri_msgs__msg__FacialLandmarks__Sequence *)allocator.allocate(sizeof(hri_msgs__msg__FacialLandmarks__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hri_msgs__msg__FacialLandmarks__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hri_msgs__msg__FacialLandmarks__Sequence__destroy(hri_msgs__msg__FacialLandmarks__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hri_msgs__msg__FacialLandmarks__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hri_msgs__msg__FacialLandmarks__Sequence__are_equal(const hri_msgs__msg__FacialLandmarks__Sequence * lhs, const hri_msgs__msg__FacialLandmarks__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hri_msgs__msg__FacialLandmarks__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hri_msgs__msg__FacialLandmarks__Sequence__copy(
  const hri_msgs__msg__FacialLandmarks__Sequence * input,
  hri_msgs__msg__FacialLandmarks__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hri_msgs__msg__FacialLandmarks);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hri_msgs__msg__FacialLandmarks * data =
      (hri_msgs__msg__FacialLandmarks *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hri_msgs__msg__FacialLandmarks__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hri_msgs__msg__FacialLandmarks__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hri_msgs__msg__FacialLandmarks__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
