// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hri_msgs:msg/Gaze.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__GAZE__TRAITS_HPP_
#define HRI_MSGS__MSG__DETAIL__GAZE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hri_msgs/msg/detail/gaze__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace hri_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Gaze & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: sender
  {
    out << "sender: ";
    rosidl_generator_traits::value_to_yaml(msg.sender, out);
    out << ", ";
  }

  // member: receiver
  {
    out << "receiver: ";
    rosidl_generator_traits::value_to_yaml(msg.receiver, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Gaze & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: sender
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sender: ";
    rosidl_generator_traits::value_to_yaml(msg.sender, out);
    out << "\n";
  }

  // member: receiver
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "receiver: ";
    rosidl_generator_traits::value_to_yaml(msg.receiver, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Gaze & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hri_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_msgs::msg::Gaze & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hri_msgs::msg::Gaze & msg)
{
  return hri_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hri_msgs::msg::Gaze>()
{
  return "hri_msgs::msg::Gaze";
}

template<>
inline const char * name<hri_msgs::msg::Gaze>()
{
  return "hri_msgs/msg/Gaze";
}

template<>
struct has_fixed_size<hri_msgs::msg::Gaze>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<hri_msgs::msg::Gaze>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<hri_msgs::msg::Gaze>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HRI_MSGS__MSG__DETAIL__GAZE__TRAITS_HPP_
