// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_msgs:msg/Group.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__GROUP__STRUCT_HPP_
#define HRI_MSGS__MSG__DETAIL__GROUP__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_msgs__msg__Group __attribute__((deprecated))
#else
# define DEPRECATED__hri_msgs__msg__Group __declspec(deprecated)
#endif

namespace hri_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Group_
{
  using Type = Group_<ContainerAllocator>;

  explicit Group_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->group_id = "";
    }
  }

  explicit Group_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    group_id(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->group_id = "";
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _group_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _group_id_type group_id;
  using _members_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _members_type members;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__group_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->group_id = _arg;
    return *this;
  }
  Type & set__members(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->members = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hri_msgs::msg::Group_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_msgs::msg::Group_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_msgs::msg::Group_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_msgs::msg::Group_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::Group_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::Group_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_msgs::msg::Group_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_msgs::msg::Group_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_msgs::msg::Group_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_msgs::msg::Group_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_msgs__msg__Group
    std::shared_ptr<hri_msgs::msg::Group_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_msgs__msg__Group
    std::shared_ptr<hri_msgs::msg::Group_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Group_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->group_id != other.group_id) {
      return false;
    }
    if (this->members != other.members) {
      return false;
    }
    return true;
  }
  bool operator!=(const Group_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Group_

// alias to use template instance with default allocator
using Group =
  hri_msgs::msg::Group_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hri_msgs

#endif  // HRI_MSGS__MSG__DETAIL__GROUP__STRUCT_HPP_
