// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_msgs:msg/SoftBiometrics.idl
// generated code does not contain a copyright notice

#ifndef HRI_MSGS__MSG__DETAIL__SOFT_BIOMETRICS__STRUCT_H_
#define HRI_MSGS__MSG__DETAIL__SOFT_BIOMETRICS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'UNDEFINED'.
enum
{
  hri_msgs__msg__SoftBiometrics__UNDEFINED = 0
};

/// Constant 'FEMALE'.
enum
{
  hri_msgs__msg__SoftBiometrics__FEMALE = 1
};

/// Constant 'MALE'.
enum
{
  hri_msgs__msg__SoftBiometrics__MALE = 2
};

/// Constant 'OTHER'.
enum
{
  hri_msgs__msg__SoftBiometrics__OTHER = 3
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/SoftBiometrics in the package hri_msgs.
/**
  * This message describes soft biometrics (age and gender)
 */
typedef struct hri_msgs__msg__SoftBiometrics
{
  std_msgs__msg__Header header;
  uint8_t age;
  float age_confidence;
  /// one of UNDEFINED, FEMALE, MALE, OTHER
  uint8_t gender;
  float gender_confidence;
} hri_msgs__msg__SoftBiometrics;

// Struct for a sequence of hri_msgs__msg__SoftBiometrics.
typedef struct hri_msgs__msg__SoftBiometrics__Sequence
{
  hri_msgs__msg__SoftBiometrics * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_msgs__msg__SoftBiometrics__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_MSGS__MSG__DETAIL__SOFT_BIOMETRICS__STRUCT_H_
